#ifndef __LOG_MESSAGE_H_
#define __LOG_MESSAGE_H_

#include <stdio.h>
#include <iostream>
#include <ostream>
#include <vector>

namespace ambenv {

  enum lm_stream {
    lm_out,
    lm_err,
    lm_warn,
    lm_info
  };

  const int lm_maxbuffer = 5000;
  
  class LogMessage {
    
  public:
    LogMessage();
    LogMessage( const FILE * out, const FILE * err, const FILE * warn );
 
    void lm_printf( char * fmt, ... );
    void lm_fprintf( lm_stream streamId, char * fmt, ... );
    
    void setInfo( std::ostream & ostream );
    void setWarn( std::ostream & ostream );

  private:
    std::vector<char> m_buffer;

    std::ostream * m_out;
    std::ostream * m_err;
    std::ostream * m_warn;
    std::ostream * m_info;

  };

}; /* namespace ambenv */

#endif /* __LOG_MESSAGE_H_ */
