#include "Random.h"

#include <cstdlib>
#include <time.h>

using namespace ambenv;

Random::Random()
{
  time_t result = time( 0 );
  if( result == ((time_t)-1) ) {
#ifdef WIN32
    srand( (unsigned)(REAL_PI * 1e8) );
#else
    srandom( (unsigned)(REAL_PI * 1e8) );
#endif
  } else {
#ifdef WIN32
    srand( result );
#else
    srandom( result );
#endif
  }
}

Random::Random( unsigned seed )
{
#ifdef WIN32
  srand( seed );
#else
  srandom( seed );
#endif
}

Real Random::getReal()
{
#ifdef WIN32
  Real r_num = (Real)rand() / (Real)RAND_MAX;
#else
  Real r_num = (Real)random() / (Real)RAND_MAX;
#endif
  return( r_num );
}

int Random::getInt()
{
#ifdef WIN32
  return( rand() );
#else
  return( random() );
#endif
}
